#include "Status.h"
#include "Vram.h"
#include "Main.h"
#include "Sprite.h"
#include "Print.h"
#include "Chars.h"

extern bool JoystickAvailable;

constexpr byte Char_Remain = Char_Man;

static ptr<byte> PrintS(ptr<byte> pVram, ptr<byte> p, bool right)
{
    byte c;
    while ((c = *p) != 0) {
        pVram = PrintC(pVram, c, right);
        right = !right;
        ++p;
    }
    return pVram;
}

void PrintStatus() 
{
    PrintS(Vram + 0 / 2, "SC", false);   
    PrintS(Vram + 9 / 2, "ST", true);
    PrintByteNumber2(Vram + 11 / 2, CurrentStage + 1, true);
    PrintC(Vram+ 14 / 2, 'T', false);
    {
        ptr<byte> pVram;
        bool right;
        pVram = Vram + 20 / 2;
        right = false;
        if (RemainCount > 1) {
            byte i;
            i = RemainCount - 1;
            if (i > 2) {
                pVram = Put2C(pVram, Char_Remain, right);
                right =!right;
                pVram = Put(pVram, Char_Space, right);
                ++pVram;
                pVram = PrintC(pVram, i + 0x30, right);
                right =!right;
            }
            else {
                do {
                    pVram = Put2C(pVram, Char_Remain, right);
                    right =!right;
                    --i;
                } while (i > 0);
            }
        }
    }
    PrintScore();
    PrintTime();
}

void PrintScore()
{
    ptr<byte> pVram;
    pVram = PrintNumber5(Vram + 2 / 2, Score, false);
    PrintByteNumberC(pVram, '0');
}

void PrintTime()
{
    ptr<byte> pVram;
    pVram = PrintByteNumber3(Vram + 15 / 2, StageTime, true);
    PrintC(pVram, ' ', false);
}

void PrintGameOver()
{
    PrintS(Vram + VramRowSize * 8 + 7 / 2, "GAME OVER", true);
    // PresendVram();
}

void PrintTimeUp() 
{
    PrintS(Vram + VramRowSize * 8 + 8 / 2, "TIME UP", true);
    // PresendVram();
}

void Title()
{
    static const byte[] TitleBytes = {
        //	C
        0x00, 0x0e, 0x05, 0x0b, 
        0x0c, 0x03, 0x00, 0x00, 
        0x04, 0x0b, 0x00, 0x0a, 
        0x00, 0x04, 0x05, 0x01, 
        //	R
        0x0c, 0x07, 0x05, 0x0b, 
        0x0c, 0x03, 0x08, 0x0f, 
        0x0c, 0x07, 0x0f, 0x02, 
        0x04, 0x01, 0x04, 0x05, 
        //	A
        0x00, 0x0e, 0x0d, 0x02, 
        0x0c, 0x03, 0x00, 0x0f, 
        0x0c, 0x07, 0x05, 0x0f, 
        0x04, 0x01, 0x00, 0x05, 
        //	C
        0x00, 0x0e, 0x05, 0x0b, 
        0x0c, 0x03, 0x00, 0x00, 
        0x04, 0x0b, 0x00, 0x0a, 
        0x00, 0x04, 0x05, 0x01, 
        //	K
        0x0c, 0x03, 0x08, 0x07, 
        0x0c, 0x0b, 0x07, 0x00, 
        0x0c, 0x03, 0x0d, 0x02, 
        0x04, 0x01, 0x00, 0x05, 
        //	Y
        0x0c, 0x03, 0x0c, 0x03, 
        0x04, 0x0b, 0x0e, 0x01, 
        0x00, 0x0c, 0x03, 0x00, 
        0x00, 0x04, 0x01, 0x00, 
    };

    ClearScreen(); 
    HideAllSprites();
    PrintStatus(); 
    {
        ptr<byte> p;
        ptr<byte> pVram;
        pVram = Vram + VramRowSize * 2 + 0 / 2;
        p = TitleBytes;
        repeat (6) {
            repeat (4) {
                bool right;
                right = false;
                repeat (4) {
                    pVram = Put(pVram, *p, right);
                    right = !right;
                    ++p;
                }
                pVram += VramRowSize - 2;
            }
            pVram += 2 - VramRowSize * 4;
        }
        PrintS(Vram + VramRowSize * 6 + 18 / 2, "MINI", false);
    }
    if (JoystickAvailable) {
        PrintS(Vram + VramRowSize * 10 + 1, "PUSH TRIGGER BUTTON", false);    
    }
    else {
        PrintS(Vram + VramRowSize * 10 + 2, "PUSH SHIFT KEY", false);
        PrintS(Vram + VramRowSize * 12 + 2, "OR CTRL KEY", false);
    }
    PrintS(Vram + VramRowSize * 14 + 6, "INUFUTO 2023", false);
    // PresendVram();
}